<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { computed, onMounted, ref } from 'vue';
import { linkify, trimHtml } from '@/lib/utils';
import Modal from '@/components/general/Modal.vue';

const props = defineProps<{
    content: string,
    fontSize?: string,
    fontStyle?: string,
    contentLength: number,
    hideHyphens?: boolean
}>();

const emits = defineEmits<{
    (e: 'dblclick'):void
}>();

const contentLength = ref(0);
const html = computed(()=>{
    if(props.content && props.content.length>0){
        if(props.contentLength<=0){
            return linkify(props.content)
        }else{
            return trimHtml(linkify(props.content),{limit:props.contentLength}).html;
        }
    }
    else
        props.content;
});

onMounted(()=>{
    contentLength.value = props.content ? props.content?.replace(/<\/?("[^"]*"|'[^']*'|[^>])*(>|$)/g, "").length: 0;
});

const isContentModalOpen = ref(false);
const showContentModal = (value:boolean)=>{
    isContentModalOpen.value = value;
}

const handleClick = ()=>{
    emits('dblclick');
}

</script>
<template>
    <div class="p-1 text-pretty break-all text-gray-700 flex flex-row gap-2" :class="hideHyphens?'hyphens-none':'hyphens-auto'"
        style="word-break:break-word" lang="de" @dblclick="handleClick">
        <p class="text-view" :class="[fontSize]" v-html="html"></p>
        <button class="hover:bg-gray-100 leading-3 text-[1em] size-5 p-1 rounded-md"
            v-if="props.contentLength>0 && contentLength>props.contentLength" @click="showContentModal(true)"><i
                class="ri-expand-diagonal-line"></i></button>
    </div>
    <Modal v-if="isContentModalOpen" @close="showContentModal(false)" :labelCancel="$t('general.buttons.close')"
        :font="fontStyle??''">
        <div class="text-3xl text-pretty break-all hyphens-auto text-gray-700" lang="de" v-html="content"></div>
    </Modal>
</template>
<style>
.text-view ul, .text-view ol{
    @apply list-inside pl-2
}

.text-view ul li p, .text-view ol li p{
    @apply inline
} 

.text-view ul {
    @apply list-disc
}
.text-view ol {
    @apply list-decimal
}

.text-view a {
    @apply underline text-blue-900 hover:text-blue-950
}
</style>